unit messageForm;

interface

uses
  Windows,SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  PxCustomTable, PxTable, PxComponent, PxVisibleComponent, PxContainer,
  PxPage, PxCustomText, PxText, HttpEng, GenEng,webmessages,
  PxSubmitButton, PxCustomInputComponent, PxTextInputField, PxInputForm,
  PxStandardComponent, PxTemplate, PxOptimizer, PxCGIExpertOptimizer;

type
  TForm1 = class(TForm)
    PxPage1: TPxPage;
    PxTable1: TPxTable;
    Engine: TGeneralHttpEngine;
    PxText1: TPxText;
    PrevText: TPxText;
    NextText: TPxText;
    PxPage2: TPxPage;
    PxInputForm1: TPxInputForm;
    PxTextInputField1: TPxTextInputField;
    PxText3: TPxText;
    PxSubmitButton1: TPxSubmitButton;
    header: TPxStandardComponent;
    bottomtemplate: TPxTemplate;
    bottom: TPxStandardComponent;
    Optimizer: TPxCGIExpertOptimizer;
    procedure EngineExecRequest(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

uses newMessageForm, ViewMessages,inifiles;

{$R *.DFM}


procedure TForm1.EngineExecRequest(Sender: TObject);
var
   done : boolean;
   m    : TMessageDesc;
   s    : TForumMessage;
   man  : TMessageManager;
   i    : integer;
   cont : boolean;
   txt  : TStringlist;
   ini  : TInifile;
   headertext  : TStringlist;
   bottomText  : TStringlist;
   filename : string;
begin
     startsession(now+1/24);
     man:=TMessageManager.create;
     man.ForumName:=Formvar('nm','');
    if man.ForumName<>'' then
    begin

     form1.BottomTemplate.setdisplayedComponent(bottom);
     form2.BottomTemplate.setdisplayedComponent(bottom);
     form3.BottomTemplate.setdisplayedComponent(bottom);



     man.LocalPath:=ExtractFilePath(Application.exename)+man.forumName+'\';

     man.table:=PxTable1;
     man.initialize;
     PxTable1.EmptyTable;
     done := false;

     ini:=TIniFile.create(man.localpath+'forum.ini');
     
     filename:=ini.readstring('forum','background','');
     form1.PxPage1.BackGroundImage:=filename;
     form2.PxPage1.BackGroundImage:=filename;
     form3.PxPage1.BackGroundImage:=filename;

     headerText:=TStringlist.create;
     filename:=ini.readstring('forum','header','');
     if filename<>'' then
          headerText.loadfromfile(man.localpath+filename);

     bottom.HTMLInside.clear;

     filename:=ini.readstring('forum','bottom','');
     BottomText:=TStringlist.create;
     if filename<>'' then
     begin
          BottomText.loadfromfile(man.localpath+filename);
          for i:=0 to bottomtext.count-1 do
               bottom.htmlinside.add(bottomtext[i]);

     end;

     if formvar('postnew','') <> '' then
     begin
         form3.header.htmlinside.clear;
         for i:=0 to headertext.count-1 do
          form3.header.htmlinside.add(headertext[i]);

         form3.ErrMess.text.clear;
         form3.NameField.value:='';
         form3.MailField.value:='';
         form3.SubjectField.Value:='';
         form3.PxInputForm1.hiddenFields.clear;
         form3.PxInputForm1.hiddenFields.add('addmes=true');
         form3.PxInputForm1.hiddenFields.add('parent='+formvar('postnew','0'));
         form3.PxInputForm1.hiddenFields.add('index='+inttostr(man.index));
         form3.PxInputForm1.hiddenFields.add('nm='+man.forumName);
         i:=strtoint(formvar('postnew','0'));
         form3.PxTextArea1.value.clear;
         if i > 0 then
         begin
                s:=man.MessagesByNumber[i];
                for i:=0 to s.text.count-1 do
                    form3.PxTextArea1.value.add('>'+s.text[i]);
                form3.SubjectField.value:='RE : '+s.desc.header;
         end;

         engine.put(form3.PxPage1.put(optimizer));
         done:=true;
     end;

     if formvar('kill','') <> '' then
     begin
          if sessionvar('login','no')='yes' then
             man.deletemessage(strtoint(formvar('kill','')));
     end;

     if formvar('addmes','') <> '' then
     begin
         form3.header.htmlinside.clear;

         for i:=0 to headertext.count-1 do
          form3.header.htmlinside.add(headertext[i]);


         form3.ErrMess.text.clear;
         m.sender  :=formvar('name','');
         m.replymail:=formvar('mail','');
         m.header:=formvar('subject','');
         if ((m.sender='') or (m.replymail='') or (m.header='')) then
         begin

              form3.ErrMess.text.add('Please fill out all fields when posting a message !');
              form3.NameField.value:=m.sender;
              form3.MailField.value:=m.replymail;
              form3.SubjectField.Value:=m.header;
              form3.PxTextArea1.Value.Clear;
              form3.PxTextArea1.Value.add(formvar('mess',''));

              form3.PxInputForm1.hiddenFields.clear;
              form3.PxInputForm1.hiddenFields.add('addmes=true');
              form3.PxInputForm1.hiddenFields.add('parent='+formvar('parent','0'));
              form3.PxInputForm1.hiddenFields.add('index='+inttostr(man.index));
              form3.PxInputForm1.hiddenFields.add('nm='+man.forumName);
              engine.put(form3.PxPage1.put(optimizer));
              done:=true;
         end
         else
         begin
              m.date:=now;
              m.number:=man.GetUniqueMessageNumber;
              m.parent:=strToInt(formvar('parent','0'));
              m.MesFile:=man.localPath+'\'+man.forumname+'_msg'+inttostr(m.number)+'.txt';
              man.addMessage(m,formvar('mess',''));
         end;

     end;

     if formvar('view','') <> '' then
     begin
        form2.header.htmlinside.clear;

        for i:=0 to headertext.count-1 do
         form2.header.htmlinside.add(headertext[i]);

        form2.PxText1.text.clear;
        s:= man.messagesByNumber[strtoint(formvar('view','0'))];
        txt:=s.text;
        form2.pxtext4.link:='forum.exe?nm='+man.forumname+'&index='+inttostr(man.index);
        form2.TextInfo.Text.clear;
        form2.TextInfo.Text.add('Message posted by '+s.desc.sender+' ( '+DateTimeToStr(s.desc.date)+' )');
        for i := 0 to txt.count-1 do
            form2.PxText1.text.add(txt[i]);

        form2.ReplyText.link:='forum.exe?nm='+man.forumname+'&postnew='+formvar('view','0')+'&index='+inttostr(man.index);
        put(form2.PxPage1.put(optimizer));
        done:=true;
     end;

     if formvar('login','') <>'' then
     begin
        PxInputform1.hiddenfields.add('nm='+man.forumname);
        put(PxPage2.put(optimizer));
        done:=true;
     end;

     if formvar('pwd','') <>'' then
     begin
          if formvar('pwd','error')=ini.readstring('forum','password','') then
          begin
               SetSessionvar('login','yes');
          end;
     end;


     i:=0;
     if not done then
     begin
        form1.header.htmlinside.clear;
        for i:=0 to headertext.count-1 do
         form1.header.htmlinside.add(headertext[i]);

        Pxtext1.link:='forum.exe?nm='+man.forumname+'&postnew=0';

        for i:=0 to Man.messageCount-1 do
        begin
         s:=man.MessagesByIndex[i];
         if ((s.desc.parent=0) and (s.desc.number>-1)) then
            man.addmessageToTable(s,0,sessionvar('login','no')='yes');

         man.index:=strtoint(formvar('index','0'));
         prevText.link:='';
         NextText.link:='';

         if man.index>0 then
            prevText.link:='forum.exe?nm='+man.forumname+'&index='+inttostr(man.index-20);

         if man.index+20<PxTable1.NumberOfRows then
            NextText.link:='forum.exe?nm='+man.forumname+'&index='+inttostr(man.index+20);

         PxTable1.StartIndex:=man.index;


        end;
         engine.put(pxPage1.put(optimizer));
     end;
    end
    else
     engine.put('<html> unknown forum </html>');

    man.free;
    ini.free;
  end;

end.
